/*



                               DEFINITIONS FILE!!!!
                                FOR ULTRA DUNE 2




*/
extern volatile int mouse_x;  //External variable holding mouse X co-ord
extern volatile int mouse_y;  //External variable holding mouse y co-ord
extern volatile int mouse_b;  //External Variable handling mouse button info


struct Structr                  // Structures
{
	int max_hitpoints;	// Max hitpoints
	int hitpoints;		// Hitpoints
	int action;		// Action
	int cell;		// Cell location
	int tpe;		// Type structure
	int player;		// Belongs to player NR
	int counter;		// Counter
	int counter2;		// Counter
	int house;		// House, so its easier to know what kind of house it is
	int dead_flag;		// Dead or not?
        int selected;           // Selected?
	int place_b;		// Building to place (for const)
	int facing;		// Building facing (for turrets)
};

struct Build                    // Building stuff
{
	// Building units and structures type
	int player;	// Which player builds this
	int type_u;	// Type of Unit?
	int type_b;	// Type of Building?
	int percent;	// 100% means done,
	int topay;	// To pay per percent
	int slowdowns;	// Slow downs for building
	int counter;	// Counter for slowdowns
	int dead_flag;	// Flag to build or not to build
};

struct pl
{
	int upgrade_4quad;	// Upgraded for Quad?
	int upgrade_4slab;	// Upgraded for 4 slabs?
	int credits;		// Credits player
	int must_credits;	// What the credits must be (for counting/discounting)
	int powerin;		// Power in
	int powerout;		// Power out
	int house;		// House

	int have_radars;	// Amount of radars
	int have_powers;	// Amount of windtraps
	int have_lights;	// Amount of Light Factories
	int have_heavys;	// Amount of Heavy Factories
	int have_refineries;	// Amount of Refineries
};

struct mp                       // Map structure
{
	int pretile;		// tile that it SHOULD be
        int tile;               // What sort of tile
        int visible;            // Visible ? (0 = YES, <> 0 = NO)
        int amount;             // Amount (for spice or minerals)
        int occupied_u;         // Occupied by a unit (0 = NO, > 0 is Unit ID)
        int nextmove;           // Next movecell of a unit (0 = NO , > 0 is Unit ID)
        int occupied_s;         // Occupied by a structure (holds ID)

};      // End of map structure

// Defines for AI
#define Human 0
#define CPU_1 1
#define CPU_2 2
#define CPU_3 3
#define CPU_4 4
#define CPU_5 5
#define CPU_6 6

#define Atreides 0
#define Harkonnen 1
#define Ordos 2
#define Sardaukar 3
#define Fremen 4
#define Mercenary 5

// For mouse
#define MOUSE_NORMAL 0
#define MOUSE_MOVE 1
#define MOUSE_ATTACK 2
#define MOUSE_BOX 3

// Sidebar ICONS
// STRUCTURES
#define ICON_Upgrade 0
#define ICON_Slab1 2
#define ICON_Slab4 1
#define ICON_Windtrap 3
#define ICON_Refinery 4
#define ICON_Silo 5  
#define ICON_Barrack 6
#define ICON_Radar 7
#define ICON_Light_Factory 8
#define ICON_Heavy_Factory 9
#define ICON_Starport 10
#define ICON_Rturret 11
#define ICON_Gturret 12
#define ICON_Wall 13
#define ICON_Hitech 14
#define ICON_Repair 15
#define ICON_Place 16
#define ICON_Cancel 17
#define ICON_Wor 19
#define ICON_Ix 20
#define ICON_Palace 21
// UNITS
#define ICON_Trike 1
#define ICON_Quad 2
#define ICON_LTank 3
#define ICON_HTank 4
#define ICON_Launcher 5
#define ICON_Harvester 6
#define ICON_Devastator 7
#define ICON_Mcv 8
#define ICON_CarryAll 9
#define ICON_Troopers 10	// Same icon for TROOPERS
#define ICON_STank 11
#define ICON_Trooper 12		// .. and TROOPER, as in DUNE II!


// Sidebar Commands for SIDEBAR_INFO
#define BAR_BUILDINGS 99
#define BAR_UNITS 98
#define BAR_NONE 97
#define BAR_AIR 96
#define BAR_INFO_BUILDING 95
#define BAR_INFO_UNIT 94
#define BAR_REPAIR 93
#define BAR_WOR 92

// Random Map generator definitions
#define SPOT_ROCK 1		// For rock spots
#define SPOT_SPICE 19		// For spice fields

// Ingame Structure and Unit names
#define ST_ConstructionYard 0                           // 0 = Const
#define ST_Windtrap 1                                   // 1 = Windtrap
#define ST_Refinery 2                                   // 2 = Refinery
#define ST_Silo 3                                       // 3 = Silo
#define ST_Barrack 4					// 4 = Barracks
#define ST_Radar 5					// 5 = Radar
#define ST_LightFact 6					// 6 = Light Factory
#define ST_HeavyFact 7					// 6 = Heavy Factory
#define ST_slab1 8					// 8 = Slab (GEN)
#define ST_slab4 9					// 9 = 4 slabs (GEN)
#define ST_Starport 10					// 10 = Starport
#define ST_Wor 11					// 11 = Wor
#define ST_IX 12					// 12 = House of IX
#define ST_Hitech 13					// 13 = Hitech fac
#define ST_GunTurret 14					// 14 = GunTurret
#define ST_RocketTurret 15				// 15 = RocketTurret
#define ST_Repair 16					// 16 = Repair fac
#define ST_Wall 17					// 17 = Wall (GEN)
